rule clean
    description = Clean
    command = rm -rf ${in}

rule cc
    description = Compile ${in}
    depfile = ${out}.d
    command = ${cc} -o ${out} -c ${cflags} -iquote ${generated}/$$(dirname ${in}) -iquote ${generated}/$$(dirname ${in}|sed 's,^${testdir}/,${srcdir}/,') $$(for class in $$(sed -n '/@startuml/ {$$! {: begin; n; /@enduml/b end; /class\|interface/ {s,\s*\(class\|interface\)\s\+[a-z.]*\([^ \t<{]\+\)[{< ].*,\2,p}; b begin; : end } }' "${in}"); do echo -D$$(dirname ${in}|awk -F/ 'BEGIN{OFS="_"}{$$1="";print toupper($$0 "_'$${class}'_private")}'); done) ${in}

rule ld
    description = Link objects into ${out}
    depfile = ${out}.d
    command = _out='${out}'; ${ld} -o '${out}' ${ldflags} $$(sed '1 d; s/\\$$//' ${out}.d) && { [ "$${_out##*.}" = so ] && chmod -x '${out}' || true; }

rule ar
    description = Link objects into ${out}
    depfile = ${out}.d
    command = ${ar} rcs ${out} $$(sed '1 d; s/\\$$//' ${out}.d)

rule objdep
    description =  Genarate depfile for ${in}
    depfile = ${out}
    command = { $
        _srcdir=$$(dirname ${in}); $
        _includes=; $
        echo; $
        get_includes() { $
            local _inc; $
            local _dir; $
            local _file; $
            local _classes="$$(sed -n '/@startuml/ {$$! {: begin; n; /@enduml/b end; /class\|interface/ {s,\s*\(class\|interface\)\s\+[a-z.]*\([^ \t<{]\+\)[{< ].*,'$$(dirname "$${1}")'/\2,p}; b begin; : end } }' "$${1}")"; $
            for _inc in $$(sed -n 's/^!include \([^!]\+\)/\1/p; s/^#include\s\+"\([A-Z][^"]\+\)\.h"/\1.c/p' "$${1}"|sort -u); do $
                echo "$${_classes}"|sed -n "s,^$$(dirname "$${1}")/$$(basename "$${_inc}" .c)$$,${generated}/\0.h,p"; $
                for _dir in $$(echo ${srcdir} ${testdir} ${srcdir}/aneth ${testdir}/aneth $$(dirname $${1}) ${srcdir}/$${_srcdir##${testdir}/}|tr ' ' '\n'|sort -u); do $
                    _file="$${_dir}/$${_inc}"; $
                    echo "$${_includes}"|grep --quiet "$${_file}" && continue; $
                    [ -f $${_file} ] && [ $${_file} != $${1} ] || continue; $
                    echo ${generated}/$${_file%%.c}.h; $
                    _includes="$${_includes}\n$${_file}"; $
                    get_includes "$${_file}"; $
                done; $
            done; $
        }; $
        get_includes ${srcdir}/aneth/Object.c; $
        get_includes ${in}; $
    } | sort -u | sed '1 s,$$,${out}: \\\n ${in} \\\n ${generated}/'$$(dirname ${in})/$$(basename ${in} .c)'.h,; 1 ! s/^/ /; $$ ! s/$$/ \\/' > ${out}

rule bindep
    description = Genarate depfile for ${in}
    depfile = ${out}
    command = deps=$$(for _inc in $$(sed '1 s,.\+:\s*\\\?,,; s,\(^\|\s\)${generated}/,,g; s/\.[hc]\(\s*\\\?\)/.c\x0/g; s/[^ ]\+\/lang\.c\x0//g; s/[^ ]\+\.[^c]\x0//g; s,\(^\| \|\x0\([^\n]\)\),\n\2,g; s/\x0//; \,${out}/${triplet}\s*,d; /[^c]$$/d;' ${in}|sort -u); do [ -f $${_inc} ] && echo ${output}/${triplet}/$$(dirname $${_inc})/$$(basename $${_inc} .c).o; done) && ninja $$deps && echo "$$deps"|sed '1 s,^,${out}:\n ,; 1 ! s/^/ /; $$ ! s/$$/ \\/;' > ${out}

rule libdep
    description = Genarate depfile ${out}
    depfile = ${output}/${triplet}/${libname}.d
    command = for src in $$(find ${srcdir} -name \*.c); do echo " ${output}/${triplet}/$${src%%.c}.o"; done|sed '1 s,^,${output}/${triplet}/${libname}: \\\n,; $$ ! s/$$/ \\/' > ${output}/${triplet}/${libname}.d && sed '1 s,${output}/${triplet}/${libname}:,${output}/${triplet}/${libname}.so:,' ${output}/${triplet}/${libname}.d > ${output}/${triplet}/${libname}.so.d && sed '1 s,${output}/${triplet}/${libname}:,${output}/${triplet}/${libname}.a:,' ${output}/${triplet}/${libname}.d > ${output}/${triplet}/${libname}.a.d

rule run
    description = Run '${in}'
    command = ./${in} ${args}

rule install
    description = Install in ${prefix}
    command = mkdir --parent ${prefix}/include/ && cp -a ${generated}/${srcdir}/* ${prefix}/include/ && mkdir --parents ${prefix}/lib/${triplet} && find ${output}/${triplet} -maxdepth 1 -type f \( -name \*.a -o -name \*.so \) -exec cp {} ${prefix}/lib/${triplet}/ \; && find ${output}/${triplet} -maxdepth 1 -type f -not -name \*.so -a -executable -exec cp {} ${prefix}/bin \; && find ${srcdir} -name \*.h -exec sh -c "header='{}'; cp \"\$${header}\" \"${prefix}/include/\$${header#${srcdir}/}\"" \;

rule puml2cclass
    description = Include UML '${in}' in a c class file '${out}'
    command = printf '#include "%s"\n\n/*!\n%s\n*/\n' "$$(basename ${in} .puml).h" "$$(cat "${in}")" > "${out}"

rule puml2x
    description = Convert UML class diagram '${in}' into '${out}'
    command = base_name=$$(basename ${in} .c); $
		namespace=$$(dirname ${in}|awk -F/ 'BEGIN{OFS="/"}{$$1="";print substr($$0,2) }'); $
		ext='${out}'; $
		ext="$${ext##*.}"; $
		indir=$$(dirname ${in}); $
		class=$$(basename ${out} .$${ext}); $
		[ xmi = "$${ext}" ] && ext=xmi:star; $
		if [ "$${base_name}" = "$${class}" ]; then $
			include=$${namespace}/$${class}.c; $
		else $
			include=$${namespace}/$${base_name}.c'!'$${class}; $
		fi; $
		printf '@startuml '$${class}'\n!include Object.c\n!include '$${include}'\n@enduml' > ${out}.puml; $
		bash -c "${java} -cp '${puml}:${classpath}' -Djava.awt.headless=true -Dplantuml.include.path=$${indir}:${generated}/$${indir}:${generated}/$$(echo $${indir}|sed 's,^${testdir}/,${srcdir}/,'):${pumlpath} net.sourceforge.plantuml.Run -Sshadowing=false -failfast -t$${ext} ${pumlflags} ${out}.puml" || { $
			rm ${out}; $
			false; $
		}

rule xmi2c
    description = Generate C file '${out}' from XMI '${in}'
    command = ${xmi2c} --mode simple --source-path '${srcdir}:${testdir}' --in ${in} $$(echo ${out}|sed 's/\(^\)\|\( \)/ --out /g')
